; ---------------------------------------------------------------------------
; Serial.s
; ---------------------------------------------------------------------------
;
; Serial Hardware Driver
;

; I tested these as well, and as expected the Linker cannot link them with the main C file

.importzp	tmp1, ptr1
.export		_ftprintc, _ftgetc

.define		FT_IN	$F700
.define		FT_OUT	$F700
.define		FT_ST	$F701

.segment "CODE"

.PC02		; Force 65C02 assembly mode

; ---------------------------------------------------------------------------
; void _ftprintc(char value)
; Writes value to SERIAL

.proc _ftprintc: near
	PHA					; Save A onto the Stack
	LDA #%00000001		; Load the bit Mask
	@WAIT:
		BIT FT_ST		; Check bit 0 of FT_ST
	BNE @WAIT			; If it's not 0, Data cannot be written to SERIAL, so jump back
	PLA					; If it is, pull A from the Stack
	STA FT_OUT			; And Throw it at SERIAL
RTS
.endproc

; ---------------------------------------------------------------------------
; char _ftgetc(void)
; Reads value from SERIAL

.proc _ftgetc: near
	LDA #%00000010		; Load the bit Mask
	@WAIT:
		BIT FT_ST		; Check bit 1 of FT_ST
	BNE @WAIT			; If it's not 0, Data cannot be read from SERIAL, so jump back
	LDA FT_IN			; If it is, Read a byte from SERIAL
	LDX #0				; Just in case, .ake sure the "High Byte" is 0
RTS
.endproc



















